# Record Class ARI1JPortDescription

java.lang.Object
java.lang.Record
com.io7m.aradine.instrument.spi1.json_data.internal.ARI1JPortDescription

Record Components:
  `kind` - The port kind
  `direction` - The port direction
  `number` - The port number
  `label` - The port label
  `semantics` - The port semantics
  `documentation` - The documentation

public record ARI1JPortDescription(ARI1JPortKind kind, ARI1JPortDirection direction, ARI1JPortNumber number, String label, Set<String> semantics, Optional<ARI1JDocumentation> documentation) extends Record
A description of a port used to supply data to, or extract data from, an instrument.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ARI1JPortDescription(ARI1JPortKind kind, ARI1JPortDirection direction, ARI1JPortNumber number, String label, Set<String> semantics, Optional<ARI1JDocumentation> documentation)`
  A description of a port used to supply data to, or extract data from, an instrument.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ARI1JPortDirection`
  `direction()`
  Returns the value of the `direction` record component.
  `Optional<ARI1JDocumentation>`
  `documentation()`
  Returns the value of the `documentation` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `ARI1JPortKind`
  `kind()`
  Returns the value of the `kind` record component.
  `String`
  `label()`
  Returns the value of the `label` record component.
  `ARI1JPortNumber`
  `number()`
  Returns the value of the `number` record component.
  `Set<String>`
  `semantics()`
  Returns the value of the `semantics` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ARI1JPortDescription

    public ARI1JPortDescription(ARI1JPortKind kind, ARI1JPortDirection direction, ARI1JPortNumber number, String label, Set<String> semantics, Optional<ARI1JDocumentation> documentation)
    A description of a port used to supply data to, or extract data from, an instrument.
    Parameters:
      `kind` - The port kind
      `direction` - The port direction
      `number` - The port number
      `label` - The port label
      `semantics` - The port semantics
      `documentation` - The documentation

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### kind

    public ARI1JPortKind kind()
    Returns the value of the `kind` record component.
    Returns:
      the value of the `kind` record component

  - ### direction

    public ARI1JPortDirection direction()
    Returns the value of the `direction` record component.
    Returns:
      the value of the `direction` record component

  - ### number

    public ARI1JPortNumber number()
    Returns the value of the `number` record component.
    Returns:
      the value of the `number` record component

  - ### label

    public String label()
    Returns the value of the `label` record component.
    Returns:
      the value of the `label` record component

  - ### semantics

    public Set<String> semantics()
    Returns the value of the `semantics` record component.
    Returns:
      the value of the `semantics` record component

  - ### documentation

    public Optional<ARI1JDocumentation> documentation()
    Returns the value of the `documentation` record component.
    Returns:
      the value of the `documentation` record component